diff -pruN 4.8.4-1/debian/changelog 4.8.4-2/debian/changelog
--- 4.8.4-1/debian/changelog	2020-12-26 06:52:30.000000000 +0000
+++ 4.8.4-2/debian/changelog	2021-01-01 23:09:23.000000000 +0000
@@ -1,3 +1,9 @@
+cinnamon (4.8.4-2) unstable; urgency=medium
+
+  * Include upstream patch for desktop files in sub-folders.
+
+ -- Norbert Preining <norbert@preining.info>  Sat, 02 Jan 2021 08:09:23 +0900
+
 cinnamon (4.8.4-1) unstable; urgency=medium
 
   [ Norbert Preining ]
diff -pruN 4.8.4-1/debian/patches/fix-desktop-subfolders.patch 4.8.4-2/debian/patches/fix-desktop-subfolders.patch
--- 4.8.4-1/debian/patches/fix-desktop-subfolders.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.8.4-2/debian/patches/fix-desktop-subfolders.patch	2021-01-01 23:09:23.000000000 +0000
@@ -0,0 +1,33 @@
+From 03a1b3d62a073db5f10550cf793c6c905b18b790 Mon Sep 17 00:00:00 2001
+From: Lars Mueller <cobinja@yahoo.de>
+Date: Fri, 1 Jan 2021 19:18:13 +0100
+Subject: [PATCH] Fix for desktop files in subfolders: use the desktop id
+ generated in cinnamon-menus
+
+Some applets (menu, gwl and panel-launchers) want to use this id
+for lookups at a later time. In the case of desktop files inside of
+subfolders, cinnamon-menus prepends the parent path to the desktop
+filename, and this is used as a key in CinnamonAppSys. This won't
+match the id returned by g_app_info_get_id() causing app-sys lookups
+to fail later on.
+---
+ src/cinnamon-app.c | 6 ++----
+ 1 file changed, 2 insertions(+), 4 deletions(-)
+
+diff --git a/src/cinnamon-app.c b/src/cinnamon-app.c
+index 14fc000942..3dcb5a55f1 100644
+--- a/src/cinnamon-app.c
++++ b/src/cinnamon-app.c
+@@ -112,10 +112,8 @@ cinnamon_app_get_property (GObject    *gobject,
+ const char *
+ cinnamon_app_get_id (CinnamonApp *app)
+ {
+-  if (app->info)
+-  {
+-    return g_app_info_get_id (G_APP_INFO (app->info));
+-  }
++  if (app->entry)
++    return gmenu_tree_entry_get_desktop_file_id (app->entry);
+   return app->window_id_string;
+ }
+ 
diff -pruN 4.8.4-1/debian/patches/series 4.8.4-2/debian/patches/series
--- 4.8.4-1/debian/patches/series	2020-12-26 06:52:30.000000000 +0000
+++ 4.8.4-2/debian/patches/series	2021-01-01 23:09:23.000000000 +0000
@@ -2,3 +2,4 @@ background.patch
 Drop-nm-applet-from-the-session-files.patch
 new-iso-flags-folder.patch
 always-add-default-theme.patch
+fix-desktop-subfolders.patch
